# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.191
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class ComponentRule(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'match_criteria': 'str',
        'components': 'dict(str, str)'
    }

    attribute_map = {
        'match_criteria': 'matchCriteria',
        'components': 'components'
    }

    required_map = {
        'match_criteria': 'required',
        'components': 'optional'
    }

    def __init__(self, match_criteria=None, components=None, local_vars_configuration=None):  # noqa: E501
        """ComponentRule - a model defined in OpenAPI"
        
        :param match_criteria:  (required)
        :type match_criteria: str
        :param components: 
        :type components: dict(str, str)

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._match_criteria = None
        self._components = None
        self.discriminator = None

        self.match_criteria = match_criteria
        self.components = components

    @property
    def match_criteria(self):
        """Gets the match_criteria of this ComponentRule.  # noqa: E501


        :return: The match_criteria of this ComponentRule.  # noqa: E501
        :rtype: str
        """
        return self._match_criteria

    @match_criteria.setter
    def match_criteria(self, match_criteria):
        """Sets the match_criteria of this ComponentRule.


        :param match_criteria: The match_criteria of this ComponentRule.  # noqa: E501
        :type match_criteria: str
        """
        if self.local_vars_configuration.client_side_validation and match_criteria is None:  # noqa: E501
            raise ValueError("Invalid value for `match_criteria`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                match_criteria is not None and len(match_criteria) > 16384):
            raise ValueError("Invalid value for `match_criteria`, length must be less than or equal to `16384`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                match_criteria is not None and len(match_criteria) < 1):
            raise ValueError("Invalid value for `match_criteria`, length must be greater than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                match_criteria is not None and not re.search(r'^[\s\S]*$', match_criteria)):  # noqa: E501
            raise ValueError(r"Invalid value for `match_criteria`, must be a follow pattern or equal to `/^[\s\S]*$/`")  # noqa: E501

        self._match_criteria = match_criteria

    @property
    def components(self):
        """Gets the components of this ComponentRule.  # noqa: E501


        :return: The components of this ComponentRule.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._components

    @components.setter
    def components(self, components):
        """Sets the components of this ComponentRule.


        :param components: The components of this ComponentRule.  # noqa: E501
        :type components: dict(str, str)
        """

        self._components = components

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComponentRule):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ComponentRule):
            return True

        return self.to_dict() != other.to_dict()
